.include "m8515def.inc"		;@18,432MHz

.equ	YCnt	= 0x0167
.equ	GrayCnt	= 0x0168
.equ	YMin	= 0x04
.equ	Xsize	= 0xf0		;Bit pro Zeile (240)
.equ	Ysize	= 0x50		;4-bit Zeilenzahl (320/4=80)
.equ	YScan	= 0xf4
.equ	text_Y	= 0x0c 		;Zeichenhhe
.equ	text_X	= 0x08		;Zeichenbreite
.equ	XOScan	= 0x05
.equ	ZproZ	= 30		;Zeichen pro Zeile	

__vectors:
	rjmp	start   	; 
	rjmp	__bad_interrupt   	
	rjmp	__bad_interrupt   
 	rjmp	__bad_interrupt   	
 	rjmp	__bad_interrupt   	
 	rjmp	__bad_interrupt   	
 	rjmp	__bad_interrupt   	
 	rjmp	__bad_interrupt  	
 	rjmp	__bad_interrupt   	
   	rjmp	__vector_9   	; uart - Empfangsroutine
   	rjmp	__bad_interrupt   	
 	rjmp	__bad_interrupt   	
	rjmp	__bad_interrupt   	
 	rjmp	__bad_interrupt   	
	rjmp	__vector_14   	; LCD - Anzeigerotine
 	rjmp	__bad_interrupt   
	rjmp	__bad_interrupt   	
__bad_interrupt:			
	rjmp	__vectors	; 


.include "font_8x12_vert.inc"


start:			
	clr		r1	
	out		sreg, r1	
	ldi		r28,low(0x025F)		; Stackadresse
	ldi		r29,high(0x025F)	
	out		sph, r29	
	out		spl, r28	
	ldi		r17,high(0x01E9)	; 1
	ldi		xl,low(0x0062)		;RAM lschen von 0x0062 .. 0x01e8
	ldi		xh,high(0x0062)
	rjmp	do_clear_bss_start	; 
			
do_clear_bss_loop:			
	st		X+, r1	
			
do_clear_bss_start:			
	cpi		xl,low(0x01E9)	
	cpc		xh, r17	
	brne	do_clear_bss_loop

	ldi		zl,low(2*anzahl)		;Anzahl Byte holen
	ldi		zh,high(2*anzahl)
	lpm		r17,z
	sts		0x0162,r17

__do_copy_data:			
	ldi		xl, 0x63	
	ldi		xh, 0x00	
	ldi		zl,low(2*startbild)		;Datenstring Startbild bertragen
	ldi		zh,high(2*startbild)
	inc		r17
	rjmp	do_copy_data_start	; 
do_copy_data_loop:			
	lpm		r0, Z+	
	st		X+, r0	
			
do_copy_data_start:			
	dec		r17
	brne	do_copy_data_loop	; 
			
	
main:			
	in		yl, spl	; 61
	in		yh, sph	; 62
	sbiw	yl, 0x0a	; 10
	in		r0, sreg	; 63
	cli		
	out		sph, r29	; 62
	out		sreg, r0	; 63
	out		spl, r28	; 61
	std		Y+2, r1	; 0x02
	std		Y+1, r1	; 0x01
	std		Y+4, r1	; 0x04
	std		Y+3, r1	; 0x03
	std		Y+6, r1	; 0x06
	std		Y+5, r1	; 0x05
	std		Y+8, r1	; 0x08
	std		Y+7, r1	; 0x07
	std		Y+10, r1	; 0x0a
	std		Y+9, r1	; 0x09
	ldi		r24, 0x03	; 3
	out		portd, r24	; 18
	ldi		r25, 0xFF	; 255
	out		ddrb, r25	; 23
	ldi		r24, 0xFE	; 254
	out		ddrd, r24	; 17
	out		ddre, r25	; 6
	out		porta, r25	; 27
	out		portc, r25	; 21
			
	rcall	lcd_init	; <lcd_init>
	ldi		r24, 0x33	; 51
	ldi		r25, 0x00	; 0
	rcall	uart_init	; <uart_init>
	clr		r7			; Koordinaten lschen
	clr		r8	
	clr		r9	
	ldi		r27, 0xFF	; 
	mov		r5, r27		;Textfarbe = ffh (wei)
	clr		r6			;Hintergrundfarbe = 0 (schwarz)

; Ansprung Befehl "30" Send directly
; Warteschleife UART-Eingang
main0x6c:			
	rcall	uart_getchar	; 0x1782 <uart_getchar>
	mov		r20, r24	
	cpi		r24, 0x20	; 32
	brcs	main0x76	; 0xcf6 <main+0x76>
	rjmp	main0x144	; 0xdc4 normales Zeichen
main0x76:			
	cpi		r24, 0x01	; 1 Cursor home
	brne	main0x7c	; 0xcfc <main+0x7c>
	rjmp	main0x134	; 0xdb4 <main+0x134>
main0x7c:			
	cpi		r24, 0x02	; 2 LCD off
	brne	main0x82	; 0xd02 <main+0x82>
	rjmp	main0x170	; 0xdf0 <main+0x170>
main0x82:			
	cpi		r24, 0x03	; 3 LCD on
	brne	main0x88	; 0xd08 <main+0x88>
	rjmp	main0x174	; 0xdf4 <main+0x174>
main0x88:			
	cpi		r24, 0x08	; 8 Backspace
	brne	main0x8e	; 0xd0e <main+0x8e>
	rjmp	main0x178	; 0xdf8 <main+0x178>
main0x8e:			
	cpi		r24, 0x09	; 9 Set pixel
	brne	main0x94	; 0xd14 <main+0x94>
	rjmp	main0x1c8	; 0xe48 <main+0x1c8>
main0x94:			
	cpi		r24, 0x0A	; 10 Line feed
	brne	main0x9a	; 0xd1a <main+0x9a>
	rjmp	main0x1b8	; 0xe38 <main+0x1b8>
main0x9a:			
	cpi		r24, 0x0B	; 11 Delete in place
	brne	main0xa0	; 0xd20 <main+0xa0>
	rjmp	main0x184	; 0xe04 <main+0x184>
main0xa0:			
	cpi		r24, 0x0C	; 12 Form feed
	brne	main0xa6	; 0xd26 <main+0xa6>
	rjmp	main0x1e2	; 0xe62 <main+0x1e2>
main0xa6:			
	cpi		r24, 0x0D	; 13 Carriage return
	brne	main0xac	; 0xd2c <main+0xac>
	rjmp	main0x136	; 0xdb6 <main+0x136>
main0xac:			
	cpi		r24, 0x0E	; 14 Set Brightness
	brne	main0xb2	; 0xd32 <main+0xb2>
	rjmp	main0x1ec	; 0xe6c <main+0x1ec>
main0xb2:			
	cpi		r24, 0x0F	; 15 Set Contrast
	brne	main0xb8	; 0xd38 <main+0xb8>
	rjmp	main0x1f0	; 0xe70 <main+0x1f0>
main0xb8:			
	cpi		r24, 0x10	; 16 Load bmp
	brne	main0xbe	; 0xd3e <main+0xbe>
	rjmp	main0x20e	; 0xe8e <main+0x20e>
main0xbe:			
	cpi		r24, 0x11	; 17 Set Cursor Position (Column and Row)
	brne	main0xc4	; 0xd44 <main+0xc4>
	rjmp	main0x26a	; 0xeea <main+0x26a>
main0xc4:			
	cpi		r24, 0x12	; 18 Draw Line
	brne	main0xca	; 0xd4a <main+0xca>
	rjmp	main0x2a0	; 0xf20 <main+0x2a0>
main0xca:			
	cpi		r24, 0x13	; 19 Draw Circle
	brne	main0xd0	; 0xd50 <main+0xd0>
	rjmp	main0x2d0	; 0xf50 <main+0x2d0>
main0xd0:			
	cpi		r24, 0x15	; 21 Textcolor
	brne	main0xd6	; 0xd56 <main+0xd6>
	rjmp	main0x2f8	; 0xf78 <main+0x2f8>
main0xd6:			
	cpi		r24, 0x16	; 22 Enable Scroll
	brne	main0xdc	; 0xd5c <main+0xdc>
	rjmp	main0x1e8	; 0xe68 <main+0x1e8>
main0xdc:			
	cpi		r24, 0x19	; 25 Set CGRAM
	brne	main0xe2	; 0xd62 <main+0xe2>
	rjmp	main0x302	; 0xf82 <main+0x302>
main0xe2:			
	cpi		r24, 0x1C	; 28 Large Number
	brne	main0xe8	; 0xd68 <main+0xe8>
	rjmp	main0x1e8	; 0xe68 <main+0x1e8>
main0xe8:			
	cpi		r24, 0x1D	; 29 Draw Block
	brne	main0xee	; 0xd6e <main+0xee>
	rjmp	main0x334	; 0xfb4 <main+0x334>
main0xee:			
	cpi		r24, 0x1E	; 30 Send directly
	breq	main0xf4	; 0xd74 <main+0xf4>
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "30" Send directly
main0xf4:			
	rcall	uart_getchar	; Ziel lesen
	and		r24, r24	
	breq	main0xfc	; Sprung benutzerdefiniertes Zeichen
	rjmp	main0x368	; Sprung normales Zeichen

; Ausgabe benutzerdefiniertes Zeichen 0 ...13
;in y-Koordinate in r9:r8, x-Koordinate in r7
main0xfc:			
	rcall	uart_getchar	;Zeichen-Nr 0 bis 9 holen
	mov		r14, r24		; 
	ldi		zl,10			; max 10 Zeichen (0 ... 9)
	cp		r14,zl
	brcc	main0x324aa
 	mov 	zl, r14			;Zeichennummer
 	ldi 	zh, text_Y		;Bytes pro Zeichen = 12
 	mul 	zl, zh
	movw 	zl, r0
  	subi 	zl, low(-0x0169)	;Startadresse Sonderzeichen
 	sbci 	zh, high(-0x0169)	;-> Z = Adresse 1. Bye des Zeichens 

	movw	r24, r8			;y-Koord nach r25:r24
	lsr		r25	
	ror		r24	
	lsr		r25	
	ror		r24				;y-Koord / 4 in r25:r24
	mov		r16, r6	
	mov		r18, r5	
	mov		r22, r7			;x-Koord in r22
	lsr		r22	
	lsr		r22				;x-Koord / 4 r22

	rcall	lcd_writeschar
	rjmp	main0x116

main0x324aa:
	rjmp	main0x6c	; 0xcec <main+0x6c>


; Wechsel auf neue Zeile
main0x12a:			
	ldi		r30,text_y	; Zeilen pro Zeichen
	add		r8, r30		; y-Koord. auf neue Zeile
	clr		r30
	adc		r9,r30

	ldi		r30,low(Ysize*4-12)   	
	cp		r8, r30	
	ldi		r30,high(Ysize*4-12) 
	cpc		r9, r30			;y-Koord <= 308 ?

	brcs	main0x136	;  
						; bei letzter Zeile home

; Ansprung Befehl "1" Cursor home
main0x134:			
	clr		r8	
	clr		r9			; y-Koord. = 0 setzen	

; Ansprung Befehl "13" Carridge return
main0x136:			
	clr		r7			; x-Koord. = 0 setzen	
	rcall	uart_getchar	
	mov		r20, r24	
	cpi		r24, 0x20	; normales Zeichen?
	brcc	main0x144	; 0xdc4 Sprung normales Zeichen
	rjmp	main0x76	; 0xcf6 Sprung Befehlscodeauswertung

; Ansprung Befehl "ab 32" Display Text
;Display Text - Zeichen ab 32 direkt ausgeben
;in Zeichencode in r24 und r20
;in y-Koordinate in r9:r8, x-Koordinate in r7
main0x144:			
	movw	r24, r8			;y-Koord nach r25:r24
	lsr		r25	
	ror		r24	
	lsr		r25	
	ror		r24				;y-Koord / 4 in r25:r24
	mov		r16, r6	
	mov		r18, r5	
	mov		r22, r7			;x-Koord in r22
	lsr		r22	
	lsr		r22				;x-Koord / 4 r22
	rcall	lcd_writechar	;y=r24,x=r22,C=r20,TC=r18,BC=r16
main0x116:
	ldi		r24,low(text_X)	;nchste Cursorposition (8 Bit Schritt)
	add		r7, r24	
	ldi		r24,Xsize ; < 240
	cp		r7,r24 		; 
	brcc	main0x16e	; 0xdee Sprung Zeilenende erreicht
	rjmp	main0x6c	; 0xcec fertig
main0x16e:			
	rjmp	main0x12a	; 0xdaa Sprung neue Zeile

; Ansprung Befehl "2" LCD off
main0x170:			
	cbi		porte,0 
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "3" LCD on
main0x174:			
	sbi		porte, 0
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "8" Backspace
main0x178:			
	ldi		r24,(-text_X)	; 
	add		r7, r24	 
	and		r7, r7	
	brlt	main0x19e	; 0xe1e <main+0x19e>

; Ansprung Befehl "11" Delete in place
main0x184:			
 	mov		r22,r7
	lsr		r22
	lsr		r22				;x-koord. / 4

main0x192:			
	mov		r16, r6	
	mov		r18, r5	
	ldi		r20, 0x20	; Leerzeichen
	movw	r24, r8			;x-Koord nach r25:r24
	lsr		r25	
	ror		r24	
	lsr		r25	
	ror		r24	
	rcall	lcd_writechar	;X=r24,Y=r22,C=r20,TC=r18,BC=r16
	rjmp	main0x6c	; 0xcec fertig

main0x19e:			
	ldi		r30,low(-text_Y)
	add		r8,r30
	ldi		r31,high(-text_Y)
	adc		r9,r31				;Y-Koord. +12
	ldi		r30,low(Ysize*4) 	
	cp		r30, r8	
	ldi		r30,high(Ysize*4) 
	cpc		r30, r9			;y-Koord <= 308 ?  
	brcc	main0x1ac	; 0xe2c <main+0x1ac>
	ldi		r30,low(Ysize*4-text_Y) 
	mov		r8, r30		
	ldi		r31,high(Ysize*4-text_Y) 	 
	mov		r9, r31		;y-Koord auf letzte Zeile
main0x1ac:			
	ldi		r30,Xsize 
	mov		r7, r30	
	ldi		r30,low(Ysize*4-text_Y) 
	mov		r8, r30		
	ldi		r31,high(Ysize*4-text_Y) 	 
	mov		r9, r31		;y-Koord auf letzte Zeile
	ldi		r24,(Xsize/text_X-1)	; 0x27	Zeichenkoord X auf letztes Zeichen;  
	rjmp	main0x192	; 0xe12 Leerzeichen ausgeben

; Ansprung Befehl "10" Line feed
main0x1b8:			
	ldi		r31,text_y	; 12 Zeilen/Zeichen
	add		r8, r31		; Cursor nchste Zeile
	clr		r31
	adc		r9,r31
	ldi		r24,low(Ysize*4-text_Y) 	
	cp		r24, r8	
	ldi		r24,high(Ysize*4-text_Y) 
	cpc		r24, r9			;y-Koord <= 308 ?

	brcs	main0x1c4	; 0xe44 Fehler
	rjmp	main0x6c	; 0xcec fertig
main0x1c4:			
	clr		r8			; y-Koord. = 0
	clr		r9
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "9" Set pixel
main0x1c8:			
	rcall	uart_getchar	; X  holen
	mov		r16, r24	
	rcall	uart_getchar	; Y low holen
	mov		r2, r24			; 
	rcall	uart_getchar	; Y high holen
	mov		r3, r24			; 
	rcall	uart_getchar	; Farbe holen
	mov		r20, r24		; Farbe nach r20	
	clr		r17	
	movw	r22, r16		; X nach r23:r22
	movw	r24, r2			; Y nach r25:r24
	rcall	lcd_setpixel	; X=r25:r24, Y=r23:r22, Farbe=r20
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "12" Form feet
main0x1e2:			
	rcall	lcd_clear	; 0x1004 <lcd_clear>
	clr		r7			; y-Koord. = 0
	rjmp	main0x136	; 0xdb6 Sprung zu"CR"

; Ansprung Befehl "28" Large number
main0x1e8:			
	rcall	uart_getchar	; 0x1782 <uart_getchar>
	rcall	uart_getchar	; 0x1782 <uart_getchar>

; Ansprung Befehl "14" Set brightness
main0x1ec:			
	rcall	uart_getchar	; 0x1782 <uart_getchar>
	rjmp	main0x6c	; 0xcec <main+0x6c>


; Ansprung Befehl "15" Set contrast
main0x1f0:			
	rcall	uart_getchar	; 0x1782 <uart_getchar>
	mov		r18, r24	
	cpi		r24, 0x65	; 101
	brcs	main0x1fa	; 0xe7a <main+0x1fa>
	ldi		r18, 0x64	; 100
main0x1fa:			
	mov		r24, r18	
	eor		r25, r25	
	add		r24, r24	
	adc		r25, r25	
	lsr		r18	
	add		r24, r18	
	adc		r25, r1	
	out		ocr1bh, r25	; 41
	out		ocr1bl, r24	; 40
	rjmp	main0x6c	; 0xcec <main+0x6c>

; Ansprung Befehl "16" Load bmp
main0x20e:			
	rcall	uart_getchar	; 0x1782 <uart_getchar>
	cpi		r24, 0xAA	; 1 Code AAh ?
	breq	main0x216	; 0xe96 Sprung ok
	rjmp	main0x6c	; 0xcec fertig
main0x216:			
	rcall	uart_getchar	; X holen in Bytes 0-239
	mov		r14, r24		; nach r14 als Y-Koord verwenden
	rcall	uart_getchar	; Y holen 0-79
	mov		r11, r24		; nach r11 als X-Koord verwenden
	rcall	uart_getchar	; XS holen in Bytes 1-240 
	mov		r15, r24		; nach r15 als YS verwenden
	rcall	uart_getchar	; YS holen 1-80
	mov		r12, r24		; nach r12 als XS verwenden
	rcall	uart_getchar	; Modus 0 -> 1bpp  1 -> 2bpp
	mov		r13, r24		; nach r13
	and		r15, r15	
	brne	main0x230	; 0xeb0 fertig bei YS=0
	rjmp	main0x6c	; 0xcec fertig 
main0x230:			
	clr		r10			; Zhler Zeilen = 0
	sbrc	r13,0		; skip bei 1Bit Bild  
	lsl		r12			; Zhler verdoppeln bei 2Bit Bildausgabe 
main0x232:	; Schleife Zeilen		
	and		r12, r12	
	breq	main0x260	; 0xee0 bei XS=0 
	mov		r17, r11	; X nach r17
	sbrc	r13,0		; skip bei 1Bit Bild  
	lsl		r17			; Zhler verdoppeln bei 2Bit Bildausgabe 
	ldi		r16, 0x00	; Zhler Byte/Zeile = 0
	rjmp	main0x24a	; zum Daten einlesen 
main0x23c:	; Modus 1 bearbeiten		
	mov		r22, r14	; Y nach r22
	mov		r24, r17	; X nach r24
	lsr		r24
	rcall	lcd_writebyteg	;X: r24, Y: r22, DATA: r20
	subi	r16, 0xFF	; Zhler Byte/Zeile + 1
	subi	r17, 0xFF	; X=X+1
	cp		r12, r16	; XS erreicht ?
	breq	main0x260	; 0xee0 <main+0x260>
main0x24a:	; Start Datenbertragung		
	rcall	uart_getchar	;Datenbyte holen
	mov		r20, r24		; und nach r20
	and		r13, r13	
	brne	main0x23c	; 0xebc Spung bei Modus 1
			; Modus 0 bearbeiten
	mov		r22, r14	; Y nach r22
	mov		r24, r17	; X nach r24
	rcall	lcd_writebyte	;X: r24, Y: r22, DATA: r20
	subi	r16, 0xFF	; Zhler Byte/Zeile + 1
	subi	r17, 0xFF	; X=X+1
	cp		r12, r16	; XS erreicht ?
	brne	main0x24a	; 0xeca Schleife Byte
main0x260:	; neue Zeile		
	inc		r10			; Zhler Zeilen + 1
	inc		r14			; Y=Y+1
	cp		r15, r10	; YS erreicht ?
	brne	main0x232	; 0xeb2 Scleife Zeilen
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "17" Set Cursor position
main0x26a:			
	rcall	uart_getchar	;x-Koordinate lesen
	mov		r7, r24			; r24 = 0 ... 58
	lsl		r7
	lsl		r7		; Cursorkoord * 4 = Bildkoord. 0..232 in r7
	rcall	uart_getchar	;y-Koordinate lesen r24 = 0..77  
	mov		r8,r24		
	clr		r9	
	add		r8, r8	
	adc		r9, r9	
	add		r8, r8	
	adc		r9, r9	; Cursorkoord * 4 = Bildkoord. 0..308 in r9:r8
	ldi		r25,low(Ysize*4) 	
	cp		r8, r25	
	ldi		r25,high(Ysize*4) 
	cpc		r9, r25			;y-Koord <= 308 ?
	brcs	main0x294	; 0xf14 Sprung i.O.
	clr		r8	
	clr		r9			; y-Koord. = 0
main0x294:			
	ldi		r30,Xsize-8 ; = 232
	cp		r30, r7		; 
	brcs	main0x29c	; Sprung Fehler
	rjmp	main0x6c	; 0xcec fertig
main0x29c:			
	clr		r7			; x-Koord = 0
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "18" Draw line
main0x2a0:			
	rcall	uart_getchar	; X1 low holen
	std		Y+1, r24	; 
	rcall	uart_getchar	; Y1 low holen
	std		Y+2, r24	; 
	rcall	uart_getchar	; Y1 high holen
	std		y+3, r24	
	rcall	uart_getchar	; X2 holen
	mov		r12, r24	; 
	rcall	uart_getchar	; Y2 low holen
	std		y+4, r24	; 
	rcall	uart_getchar	; Y2 high holen
	mov		r21, r24	
	rcall	uart_getchar	; Farbe holen
	clr		r13	
	mov		r16, r24	; Farbe nach r16
	movw	r18, r12	; X2 nach r19:r18
	ldd		r20, Y+4	; Y2 nach r21:r20
	clr		r23	
	ldd		r22, Y+1	; X1 nach r23:r22
	ldd		r24, Y+2	; 
	ldd		r25, Y+3	; Y1 nach r25:r24
	rcall	lcd_line	; 
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "19" Draw circle
main0x2d0:			
	rcall	uart_getchar	; X1 holen
	std		Y+5, r24	; 0x05
	rcall	uart_getchar	; Y1 low holen
	mov		r14, r24	; 0x06
	rcall	uart_getchar	; Y1 high holen
	mov		r15, r24	
	rcall	uart_getchar	; R holen
	mov		r13, r24	
	rcall	uart_getchar	; Fllfarbe holen
	mov		r17, r24	
	rcall	uart_getchar	; Rahmenfarbe holen
	mov		r16, r24	; Rahmenfarbe nach r16	
	mov		r18, r17	; Fllfarbe nach r18
	mov		r20, r13	; Radius nach r20
	clr		r23
	ldd		r22, Y+5	; X1 nach r23:r22
	movw	r24, r14	; Y1 nach r25:r24
	rcall	lcd_circle	; 
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "21" Text color
main0x2f8:			
	rcall	uart_getchar	
	mov		r5, r24			; Textfarbe nach r5
	rcall	uart_getchar	
	mov		r6, r24			; Hintergrundfarbe nach r6
	rjmp	main0x6c	; 0xcec fertig

; Ansprung Befehl "25" Set CGRAM
main0x302:			
	rcall	uart_getchar	; Zeichennummer holen
	mov		r14, r24		; 
	ldi		zl,10			; max 10 Zeichen (0 ... 9)
	cp		r14,zl
	brcc	main0x324a
 	mov 	zl, r14			;Zeichennummer
 	ldi 	zh, text_Y		;Bytes pro Zeichen = 12
 	mul 	zl, zh
	movw 	zl, r0
  	subi 	zl, low(-0x0169)	;Startadresse Sonderzeichen
 	sbci 	zh, high(-0x0169)	;-> Z = Adresse 1. Bye des Zeichens 
	movw	r14,zl
	ldi		r17, 0x00	; Bytezhler = 0
main0x324:			
	rcall	uart_getchar	; 0x1782 <uart_getchar>
	movw	zh:zl,r15:r14	; Speicheradresse nach Z
	st		Z+, r24			; abspeichern, Z+1
	movw	r15:r14,zh:zl	; akt. Z nach r15:r14
	subi	r17, 0xFF		; r17 + 1
	cpi		r17, 0x0c		; 12 erreicht?
	brne	main0x324		; 0xfa4 Schleife
main0x324a:
	rjmp	main0x6c		; 0xcec <fertig

; Ansprung Befehl "29" Draw block (Rechteck)
main0x334:			
	rcall	uart_getchar	; X1  holen
	std		Y+7, r24	; 
	rcall	uart_getchar	; Y1 low holen
	mov		r10, r24	; 
	rcall	uart_getchar	; Y1 high holen
	mov		r11, r24	
	rcall	uart_getchar	; X2 holen
	std		Y+8, r24	; 
	rcall	uart_getchar	; Y2 low holen
	mov		r12, r24	; 
	rcall	uart_getchar	; Y2 high holen
	mov		r13, r24	
	rcall	uart_getchar	; Fllfarbe holen
	mov		r16, r24	
	rcall	uart_getchar	; Rahmenfarbe holen
	mov		r14, r24		; Rahmenfarbe nach r14
	ldd		r18, Y+8	; 
	clr		r19				; X2 nach r19:r18
	movw	r20, r12		; Y2 nach r21:r20
	clr		r23
	ldd		r22, Y+7		; X1 nach r23:r22
	movw	r24, r10		; Y1 nach r25:r24
	rcall	lcd_block	; 
	rjmp	main0x6c		; 0xcec fertig

; normales Zeichen ber Befehl "30" ausgeben
main0x368:			
	rcall	uart_getchar	; Zeichen 0 ... 256 whlen
	mov		r20, r24	
	movw	r24, r8		;y-Koord nach r25:r24
	lsr		r25	
	ror		r24	
	lsr		r25	
	ror		r24			;y-Koord / 4 in r25:r24
	mov		r16, r6	
	mov		r18, r5	
	mov		r22, r7		;x-Koord in r22
	lsr		r22	
	lsr		r22				;x-Koord / 4 r22
	rcall	lcd_writechar	;y=r24,x=r22,C=r20,TC=r18,BC=r16
	rjmp	main0x116	; 0xd96 <main+0x116>
			
lcd_clear:			
	ldi		r30, 0x00	; 0
	ldi		r31, 0x04	; Display-RAM Anfang 0x0400 bis 0xffff
lcd_clear0x4:			
	st		Z+, r1	
	sbiw	r30, 0x00	; wenn Z = 0 fertig
	brne	lcd_clear0x4	; 0x1008 <lcd_clear+0x4>
	ret		

bresenham_line:			
	push	r3	
	push	r4	
	push	r5	
	push	r6	
	push	r7	
	push	r8	
	push	r9	
	push	r10	
	push	r11	
	push	r12	
	push	r13	
	push	r14	
	push	r15	
	push	r16	
	push	r17	
	push	r28	
	push	r29	
	movw	r14, r24	
	movw	r8, r22	
	movw	r10, r20	
	movw	r12, r18	
	mov		r3, r16	
	sub		r10, r24	
	sbc		r11, r25	
	sub		r12, r22	
	sbc		r13, r23	
	cp		r1, r10	
	cpc		r1, r11	
	brlt	bresenham_line0x3c	; 0x112e <bresenham_line+0x3c>
	rjmp	bresenham_line0x106	; 0x11f8 <bresenham_line+0x106>
bresenham_line0x3c:			
	ldi		r22, 0x01	; 1
	mov		r4, r22	
bresenham_line0x40:			
	cp		r1, r12	
	cpc		r1, r13	
	brlt	bresenham_line0x48	; 0x113a <bresenham_line+0x48>
	rjmp	bresenham_line0xf8	; 0x11ea <bresenham_line+0xf8>
bresenham_line0x48:			
	ldi		r20, 0x01	; 1
	mov		r5, r20	
bresenham_line0x4c:			
	mov		r20, r3	
	movw	r22, r8	
	movw	r24, r14	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	cp		r10, r12	
	cpc		r11, r13	
	brlt	bresenham_line0xac	; 0x119e <bresenham_line+0xac>
	cp		r10, r1	
	cpc		r11, r1	
	brne	bresenham_line0x62	; 0x1154 <bresenham_line+0x62>
	rjmp	bresenham_line0x114	; 0x1206 <bresenham_line+0x114>
bresenham_line0x62:			
	movw	r28, r12	
	add		r28, r28	
	adc		r29, r29	
	mov		r6, r4	
	eor		r7, r7	
	sbrc	r6, 7	
	com		r7	
	movw	r16, r14	
	movw	r14, r8	
	eor		r8, r8	
	eor		r9, r9	
	mov		r4, r5	
	eor		r5, r5	
	sbrc	r4, 7	
	com		r5	
bresenham_line0x80:			
	add		r28, r12	
	adc		r29, r13	
	cp		r28, r10	
	cpc		r29, r11	
	brlt	bresenham_line0x92	; 0x1184 <bresenham_line+0x92>
	sub		r28, r10	
	sbc		r29, r11	
	add		r14, r4	
	adc		r15, r5	
bresenham_line0x92:			
	add		r16, r6	
	adc		r17, r7	
	mov		r20, r3	
	movw	r22, r14	
	movw	r24, r16	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	sec		
	adc		r8, r1	
	adc		r9, r1	
	cp		r10, r8	
	cpc		r11, r9	
	brne	bresenham_line0x80	; 0x1172 <bresenham_line+0x80>
	rjmp	bresenham_line0x114	; 0x1206 <bresenham_line+0x114>
bresenham_line0xac:			
	cp		r12, r1	
	cpc		r13, r1	
	breq	bresenham_line0x114	; 0x1206 <bresenham_line+0x114>
	movw	r28, r10	
	add		r28, r28	
	adc		r29, r29	
	mov		r6, r5	
	eor		r7, r7	
	sbrc	r6, 7	
	com		r7	
	movw	r16, r8	
	eor		r8, r8	
	eor		r9, r9	
	eor		r5, r5	
	sbrc	r4, 7	
	com		r5	
bresenham_line0xcc:			
	add		r28, r10	
	adc		r29, r11	
	cp		r28, r12	
	cpc		r29, r13	
	brlt	bresenham_line0xde	; 0x11d0 <bresenham_line+0xde>
	sub		r28, r12	
	sbc		r29, r13	
	add		r14, r4	
	adc		r15, r5	
bresenham_line0xde:			
	add		r16, r6	
	adc		r17, r7	
	mov		r20, r3	
	movw	r22, r16	
	movw	r24, r14	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	sec		
	adc		r8, r1	
	adc		r9, r1	
	cp		r12, r8	
	cpc		r13, r9	
	brne	bresenham_line0xcc	; 0x11be <bresenham_line+0xcc>
	rjmp	bresenham_line0x114	; 0x1206 <bresenham_line+0x114>
bresenham_line0xf8:			
	com		r13	
	neg		r12	
	sbc		r13, r1	
	inc		r13	
	ldi		r19, 0xFF	; 255
	mov		r5, r19	
	rjmp	bresenham_line0x4c	; 0x113e <bresenham_line+0x4c>
bresenham_line0x106:			
	com		r11	
	neg		r10	
	sbc		r11, r1	
	inc		r11	
	ldi		r21, 0xFF	; 255
	mov		r4, r21	
	rjmp	bresenham_line0x40	; 0x1132 <bresenham_line+0x40>
bresenham_line0x114:			
	pop		r29	
	pop		r28	
	pop		r17	
	pop		r16	
	pop		r15	
	pop		r14	
	pop		r13	
	pop		r12	
	pop		r11	
	pop		r10	
	pop		r9	
	pop		r8	
	pop		r7	
	pop		r6	
	pop		r5	
	pop		r4	
	pop		r3	
	ret		
			

lcd_line:			
	push	r8	
	push	r9	
	push	r10	
	push	r11	
	push	r12	
	push	r13	
	push	r14	
	push	r15	
	push	r16	
	push	r28	
	push	r29	
	movw	r8, r24	
	movw	r10, r22	
	movw	r12, r20	
	movw	r14, r18	
	cp		r22, r18	
	cpc		r23, r19	
	breq	lcd_line0x4a	; 0x1274 <lcd_line+0x4a>
	cp		r24, r20	
	cpc		r25, r21	
	breq	lcd_line0x2e	; 0x1258 <lcd_line+0x2e>
	rcall	bresenham_line	; 0x10f2 <bresenham_line>
	rjmp	lcd_line0x6e	; 0x1298 <lcd_line+0x6e>
lcd_line0x2e:			
	cp		r18, r22	
	cpc		r19, r23	
	brcc	lcd_line0x66	; 0x1290 <lcd_line+0x66>
	movw	r28, r18	
	movw	r14, r22	
lcd_line0x38:			
	mov		r20, r16	
	movw	r22, r28	
	movw	r24, r8	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	adiw	r28, 0x01	; 1
	cp		r14, r28	
	cpc		r15, r29	
	brcc	lcd_line0x38	; 0x1262 <lcd_line+0x38>
	rjmp	lcd_line0x6e	; 0x1298 <lcd_line+0x6e>
lcd_line0x4a:			
	cp		r20, r24	
	cpc		r21, r25	
	brcc	lcd_line0x6a	; 0x1294 <lcd_line+0x6a>
	movw	r28, r20	
	movw	r12, r24	
lcd_line0x54:			
	mov	r20, r16	
	movw	r22, r10	
	movw	r24, r28	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	adiw	r28, 0x01	; 1
	cp		r12, r28	
	cpc		r13, r29	
	brcc	lcd_line0x54	; 0x127e <lcd_line+0x54>
	rjmp	lcd_line0x6e	; 0x1298 <lcd_line+0x6e>
lcd_line0x66:			
	movw	r28, r22	
	rjmp	lcd_line0x38	; 0x1262 <lcd_line+0x38>
lcd_line0x6a:			
	movw	r28, r24	
	rjmp	lcd_line0x54	; 0x127e <lcd_line+0x54>
lcd_line0x6e:			
	pop		r29	
	pop		r28	
	pop		r16	
	pop		r15	
	pop		r14	
	pop		r13	
	pop		r12	
	pop		r11	
	pop		r10	
	pop		r9	
	pop		r8	
	ret		
			
lcd_block:
;in: x1 = r25:r24, y1 = r23:r22
;    x2 = r21:r20, y2 = r19:r18
;    Rahmen = r14, Fllung = r16			
	push	r3	
	push	r4	
	push	r5	
	push	r6	
	push	r7	
	push	r8	
	push	r9	
	push	r10	
	push	r11	
	push	r12	
	push	r13	
	push	r14	
	push	r15	
	push	r16	
	push	r17	
	push	r28	
	push	r29	
	movw	r4, r24	
	movw	r6, r22	
	movw	r8, r20	
	movw	r12, r18	
	mov		r17, r16	
	mov		r3, r14	
	movw	r10, r24	
	sec		
	adc		r10, r1	
	adc		r11, r1	
	cp		r10, r20	
	cpc		r11, r21	
	brcc	lcd_block0x62	; 0x1312 <lcd_block+0x62>
	movw	r28, r22	
	adiw	r28, 0x01	; 1
	cp		r28, r18	
	cpc		r29, r19	
	brcc	lcd_block0x62	; 0x1312 <lcd_block+0x62>
	movw	r14, r20	
	sec		
	sbc		r14, r1	
	sbc		r15, r1	
lcd_block0x4e:			
	mov		r16, r17	
	movw	r18, r28	
	movw	r20, r14	
	movw	r22, r28	
	movw	r24, r10	
	rcall	lcd_line	; 0x122a <lcd_line>
	adiw	r28, 0x01	; 1
	cp		r28, r12	
	cpc		r29, r13	
	brcs	lcd_block0x4e	; 0x12fe <lcd_block+0x4e>
lcd_block0x62:			
	mov		r16, r3	
	movw	r18, r6	
	movw	r20, r8	
	movw	r22, r6	
	movw	r24, r4	
	rcall	lcd_line	; 0x122a <lcd_line>
	movw	r18, r12	
	movw	r20, r8	
	movw	r22, r6	
	movw	r24, r8	
	rcall	lcd_line	; 0x122a <lcd_line>
	movw	r18, r12	
	movw	r20, r4	
	movw	r22, r12	
	movw	r24, r8	
	rcall	lcd_line	; 0x122a <lcd_line>
	movw	r18, r6	
	movw	r20, r4	
	movw	r22, r12	
	movw	r24, r4	
	rcall	lcd_line	; 0x122a <lcd_line>
	pop		r29	
	pop		r28	
	pop		r17	
	pop		r16	
	pop		r15	
	pop		r14	
	pop		r13	
	pop		r12	
	pop		r11	
	pop		r10	
	pop		r9	
	pop		r8	
	pop		r7	
	pop		r6	
	pop		r5	
	pop		r4	
	pop		r3	
	ret		
			
lcd_circle:	
;in: x1 = r25:r24, y1 = r23:r22
;    R  = r20, 
;    Rahmen = r16, Fllung = r18			
	push	r2	
	push	r3	
	push	r4	
	push	r5	
	push	r6	
	push	r7	
	push	r8	
	push	r9	
	push	r10	
	push	r11	
	push	r12	
	push	r13	
	push	r14	
	push	r15	
	push	r16	
	push	r17	
	push	r28	
	push	r29	
	in		r28, spl	; 61
	in		r29, sph	; 62
	sbiw	r28, 0x13	; 19
	in		r0, sreg	; 63
	cli		
	out		sph, r29	; 62
	out		sreg, r0	; 63
	out		spl, r28	; 61
	std		Y+11, r25	; 0x0b
	std		Y+10, r24	; 0x0a
	std		Y+13, r23	; 0x0d
	std		Y+12, r22	; 0x0c
	std		Y+14, r20	; 0x0e
	mov		r17, r18	
	std		Y+15, r16	; 0x0f
	mov		r8, r20	
	eor		r9, r9	
	cp		r24, r8	
	cpc		r25, r9	
	brcc	lcd_circle0x4e	; 0x13ae <lcd_circle+0x4e>
	rjmp	lcd_circle0x23e	; 0x159e <lcd_circle+0x23e>
lcd_circle0x4e:			
	cp		r22, r8	
	cpc		r23, r9	
	brcc	lcd_circle0x56	; 0x13b6 <lcd_circle+0x56>
	rjmp	lcd_circle0x23e	; 0x159e <lcd_circle+0x23e>
lcd_circle0x56:			
	and		r20, r20	
	brne	lcd_circle0x5c	; 0x13bc <lcd_circle+0x5c>
	rjmp	lcd_circle0x23e	; 0x159e <lcd_circle+0x23e>
lcd_circle0x5c:			
	movw	r24, r8	
	add		r24, r24	
	adc		r25, r25	
	ldi		r18, 0x03	; 3
	ldi		r19, 0x00	; 0
	sub		r18, r24	
	sbc		r19, r25	
	std		Y+2, r19	; 0x02
	std		Y+1, r18	; 0x01
	std		Y+9, r20	; 0x09
	movw	r10, r18	
	movw	r12, r8	
	std		Y+4, r1	; 0x04
	std		Y+3, r1	; 0x03
	ldi		r24, 0x06	; 6
	ldi		r25, 0x00	; 0
	std		Y+6, r25	; 0x06
	std		Y+5, r24	; 0x05
	std		Y+17, r23	; 0x11
	std		Y+16, r22	; 0x10
	movw	r2, r22	
	ldd		r4, Y+10	; 0x0a
	ldd		r5, Y+11	; 0x0b
	movw	r6, r4	
	rjmp	lcd_circle0xec	; 0x144c <lcd_circle+0xec>
lcd_circle0x8e:			
	ldd		r24, Y+9	; 0x09
	subi	r24, 0x01	; 1
	std		Y+9, r24	; 0x09
	mov		r12, r24	
	eor		r13, r13	
	ldd		r24, Y+3	; 0x03
	ldd		r25, Y+4	; 0x04
	sub		r24, r12	
	sbc		r25, r13	
	add		r24, r24	
	adc		r25, r25	
	add		r24, r24	
	adc		r25, r25	
	ldi		r30, 0x0A	; 10
	ldi		r31, 0x00	; 0
	add		r10, r30	
	adc		r11, r31	
	add		r10, r24	
	adc		r11, r25	
lcd_circle0xb4:			
	ldd		r18, Y+3	; 0x03
	ldd		r19, Y+4	; 0x04
	subi	r18, 0xFF	; 255
	sbci	r19, 0xFF	; 255
	std		Y+4, r19	; 0x04
	std		Y+3, r18	; 0x03
	sec		
	adc		r6, r1	
	adc		r7, r1	
	sec		
	sbc		r4, r1	
	sbc		r5, r1	
	sec		
	adc		r2, r1	
	adc		r3, r1	
	ldd		r24, Y+16	; 0x10
	ldd		r25, Y+17	; 0x11
	sbiw	r24, 0x01	; 1
	std		Y+17, r25	; 0x11
	std		Y+16, r24	; 0x10
	ldd		r30, Y+5	; 0x05
	ldd		r31, Y+6	; 0x06
	adiw	r30, 0x04	; 4
	std		Y+6, r31	; 0x06
	std		Y+5, r30	; 0x05
	cp		r12, r18	
	cpc		r13, r19	
	brcs	lcd_circle0x14a	; 0x14aa <lcd_circle+0x14a>
lcd_circle0xec:			
	ldd		r22, Y+12	; 0x0c
	ldd		r23, Y+13	; 0x0d
	add		r22, r12	
	adc		r23, r13	
	mov		r16, r17	
	movw	r18, r22	
	movw	r20, r6	
	movw	r24, r4	
	rcall	lcd_line	; 0x122a <lcd_line>
	ldd		r22, Y+12	; 0x0c
	ldd		r23, Y+13	; 0x0d
	sub		r22, r12	
	sbc		r23, r13	
	movw	r18, r22	
	movw	r20, r6	
	movw	r24, r4	
	rcall	lcd_line	; 0x122a <lcd_line>
	ldd		r14, Y+10	; 0x0a
	ldd		r15, Y+11	; 0x0b
	add		r14, r12	
	adc		r15, r13	
	ldd		r30, Y+10	; 0x0a
	ldd		r31, Y+11	; 0x0b
	sub		r30, r12	
	sbc		r31, r13	
	movw	r12, r30	
	movw	r18, r2	
	movw	r20, r14	
	movw	r22, r2	
	movw	r24, r30	
	rcall	lcd_line	; 0x122a <lcd_line>
	ldd		r18, Y+16	; 0x10
	ldd		r19, Y+17	; 0x11
	movw	r20, r14	
	movw	r22, r18	
	movw	r24, r12	
	rcall	lcd_line	; 0x122a <lcd_line>
	sbrs	r11, 7	
	rjmp	lcd_circle0x8e	; 0x13ee <lcd_circle+0x8e>
	ldd		r18, Y+5	; 0x05
	ldd		r19, Y+6	; 0x06
	add		r10, r18	
	adc		r11, r19	
	ldd		r19, Y+9	; 0x09
	mov		r12, r19	
	eor		r13, r13	
	rjmp	lcd_circle0xb4	; 0x1414 <lcd_circle+0xb4>
lcd_circle0x14a:			
	ldd		r12, Y+14	; 0x0e
	eor		r2, r2	
	eor		r3, r3	
	ldi		r18, 0x06	; 6
	ldi		r19, 0x00	; 0
	std		Y+8, r19	; 0x08
	std		Y+7, r18	; 0x07
	ldd		r4, Y+10	; 0x0a
	ldd		r5, Y+11	; 0x0b
	ldd		r10, Y+12	; 0x0c
	ldd		r11, Y+13	; 0x0d
	movw	r6, r10	
	std		Y+19, r5	; 0x13
	std		Y+18, r4	; 0x12
	rjmp	lcd_circle0x1c0	; 0x1520 <lcd_circle+0x1c0>
lcd_circle0x168:			
	dec		r12	
	mov		r8, r12	
	eor		r9, r9	
	movw	r24, r2	
	sub		r24, r8	
	sbc		r25, r9	
	add		r24, r24	
	adc		r25, r25	
	add		r24, r24	
	adc		r25, r25	
	ldd		r18, Y+1	; 0x01
	ldd		r19, Y+2	; 0x02
	subi	r18, 0xF6	; 246
	sbci	r19, 0xFF	; 255
	add		r18, r24	
	adc		r19, r25	
	std		Y+2, r19	; 0x02
	std		Y+1, r18	; 0x01
lcd_circle0x18c:			
	sec		
	adc		r2, r1	
	adc		r3, r1	
	ldd		r24, Y+18	; 0x12
	ldd		r25, Y+19	; 0x13
	adiw	r24, 0x01	; 1
	std		Y+19, r25	; 0x13
	std		Y+18, r24	; 0x12
	sec		
	adc		r6, r1	
	adc		r7, r1	
	sec		
	sbc		r10, r1	
	sbc		r11, r1	
	sec		
	sbc		r4, r1	
	sbc		r5, r1	
	ldd		r30, Y+7	; 0x07
	ldd		r31, Y+8	; 0x08
	adiw	r30, 0x04	; 4
	std		Y+8, r31	; 0x08
	std		Y+7, r30	; 0x07
	cp		r8, r2	
	cpc		r9, r3	
	brcc	lcd_circle0x1c0	; 0x1520 <lcd_circle+0x1c0>
	rjmp	lcd_circle0x23e	; 0x159e <lcd_circle+0x23e>
lcd_circle0x1c0:			
	ldd		r14, Y+12	; 0x0c
	ldd		r15, Y+13	; 0x0d
	add		r14, r8	
	adc		r15, r9	
	ldd		r20, Y+15	; 0x0f
	movw	r22, r14	
	ldd		r24, Y+18	; 0x12
	ldd		r25, Y+19	; 0x13
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	ldd		r16, Y+10	; 0x0a
	ldd		r17, Y+11	; 0x0b
	add		r16, r8	
	adc		r17, r9	
	ldd		r20, Y+15	; 0x0f
	movw	r22, r6	
	movw	r24, r16	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	ldd		r20, Y+15	; 0x0f
	movw	r22, r10	
	movw	r24, r16	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	ldd		r16, Y+12	; 0x0c
	ldd		r17, Y+13	; 0x0d
	sub		r16, r8	
	sbc		r17, r9	
	ldd		r20, Y+15	; 0x0f
	movw	r22, r16	
	ldd		r24, Y+18	; 0x12
	ldd		r25, Y+19	; 0x13
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	ldd		r20, Y+15	; 0x0f
	movw	r22, r16	
	movw	r24, r4	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	ldd		r16, Y+10	; 0x0a
	ldd		r17, Y+11	; 0x0b
	sub		r16, r8	
	sbc		r17, r9	
	ldd		r20, Y+15	; 0x0f
	movw	r22, r10	
	movw	r24, r16	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	ldd		r20, Y+15	; 0x0f
	movw	r22, r6	
	movw	r24, r16	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	ldd		r20, Y+15	; 0x0f
	movw	r22, r14	
	movw	r24, r4	
	rcall	lcd_setpixel	; 0x183e <lcd_setpixel>
	ldd		r24, Y+1	; 0x01
	ldd		r25, Y+2	; 0x02
	sbrs	r25, 7	
	rjmp	lcd_circle0x168	; 0x14c8 <lcd_circle+0x168>
	ldd		r30, Y+7	; 0x07
	ldd		r31, Y+8	; 0x08
	add		r24, r30	
	adc		r25, r31	
	std		Y+2, r25	; 0x02
	std		Y+1, r24	; 0x01
	mov		r8, r12	
	eor		r9, r9	
	rjmp	lcd_circle0x18c	; 0x14ec <lcd_circle+0x18c>
lcd_circle0x23e:			
	adiw	r28, 0x13	; 19
	in		r0, sreg	; 63
	cli		
	out		sph, r29	; 62
	out		sreg, r0	; 63
	out		spl, r28	; 61
	pop		r29	
	pop		r28	
	pop		r17	
	pop		r16	
	pop		r15	
	pop		r14	
	pop		r13	
	pop		r12	
	pop		r11	
	pop		r10	
	pop		r9	
	pop		r8	
	pop		r7	
	pop		r6	
	pop		r5	
	pop		r4	
	pop		r3	
	pop		r2	
	ret		

lcd_string:
; Ausgabe Zeichenkette	aus ROM bis =00
; in: x-Koord 0..59 in r22, y-Koord 0..79 in r24, Adresse Zeichenfolge in r21:r20
; Textfarbe in r18, Hintergrundfarbe in r16		
	push	r13	
	push	r14	
	push	r15	
	push	r16	
	push	r17	
	push	r28	
	push	r29	
	mov		r13, r24		; Y-Adr nach r13
	movw	r30, r20		; Stringadresse nach Z
	mov		r14, r18		; TC nach r14 sichern
	mov		r15, r16		; BC nach r15 sichern
	lpm		r20, Z			; 1. Zeichen
	and		r20, r20		; = 0 ?
	breq	lcd_string0x3a	; r20=0 dann fertig
	movw	r28, r30	; 
	adiw	r28, 0x01		; Z nach r29:r28 + 1
	rjmp	lcd_string0x24	; 0x15f4 <lcd_string+0x24>
lcd_string0x22:			
	mov		r22, r17	; X-Koord. wieder herstellen
lcd_string0x24:			
	mov		r17, r22	; X-Koord nach r17 sichern
	subi	r17, (-2) ;0xFE	; X-Koord fr nchstes Zeichen +2
	mov		r16, r15	; BC wieder herstellen
	mov		r18, r14	; TC wieder herstellen
	mov		r24, r13	; y-Koord. wieder herstellen
	rcall	lcd_writechar	; X=r24,Y=r22,C=r20,TC=r18,BC=r16
	movw	r30, r28	; Z aus r29:r28 wieder herstellen
	adiw	r28, 0x01	; r29:r28 + 1 fr ncstes Zeichen
	lpm		r20, Z		; nchstes Zeichen holen
	and		r20, r20	; = 00 ?
	brne	lcd_string0x22	; Ausgabeschleife bis r20=00
lcd_string0x3a:			
	pop		r29	
	pop		r28	
	pop		r17	
	pop		r16	
	pop		r15	
	pop		r14	
	pop		r13	
	ret		
			
lcd_init:			
	push	r14	
	push	r16	
	cli		
	ldi		r24, 0x18	; 24
	in		r0, sreg	; 63
	cli		
	out		wdtcr, r24	; wdce = 1, wde 1
	out		wdtcr, r1	; = 0
	out		sreg, r0	; 63
	ldi		r24, 0x80	; 128
	out		mcucr, r24	; 53
	ldi		r24,low(0x000a)	; 10
	ldi		r25,high(0x000a)	; 0
	out		ocr1ah, r25	; 43
	out		ocr1al, r24	; 42
	ldi		r24,low(0x0080)	; 
	ldi		r25,high(0x0080)	; Kontrasteinstellung
	out		ocr1bh, r25	; 41
	out		ocr1bl, r24	; 40
	ldi		r24, 0x31	; 49
	out		tccr1a, r24	; 47
	ldi		r25, 0x01	; 1
	out		tccr1b, r25	; 46
	ldi		r24, 0x61	; 97
	out		ocr0, r24	; 49
	ldi		r24, 0x0A	; 10
	out		tccr0, r24	; 51
	out		timsk, r25	; 57
	sei		
	rcall	lcd_clear	; 0x1004 <lcd_clear>


	ldi		r24, 0x18	; 24
	ldi		r25, 0x00	; 0
	ldi		r18, 0x0C	; 12
	in		r0, sreg	; 63
	cli		
	wdr		
	out		wdtcr, r24	; 33
	out		sreg, r0	; 63
	out		wdtcr, r18	; 33
	sbi		porte, 0	; 7
	pop		r16	
	pop		r14	
	ret		
			
__vector_9:		; UART-Empfangsroutine	
	push	r1	
	push	r0	
	in		r0, sreg	; 63
	push	r0	
	clr		r1	
	push	r24	
	push	r25	
	push	zl	
	push	zh	
	in		r25, UDR	; USART io-data-Register
	lds		zl, 0x0162	
	subi	zl, 0xFF	; 255
	lds		r24, 0x0163	
	cp		zl, r24	
	breq	Vect90x50	
	sts		0x0162, r30	
	clr		r31	
	subi	zl, 0x9E	; 158
	sbci	zh, 0xFF	; 255
	st		Z, r25	
	lds		r24, 0x0164	
	lds		r25, 0x0165	
	adiw	r24, 0x01	; 1
	sts		0x0165, r25	
	sts		0x0164, r24	
	lds		r24, 0x0164	
	lds		r25, 0x0165	
	cpi		r24, 0xC1	; 193
	cpc		r25, r1	
	brcs	Vect90x50	; 0x174c <__vector_9+0x50>
	sbi		portd, 2	; 18
Vect90x50:			
	pop		zh	
	pop		zl	
	pop		r25	
	pop		r24	
	pop		r0	
	out		sreg, r0	; 63
	pop		r0	
	pop		r1	
	reti		
			

uart_init:			
;	sts		0x0162, r1	; UART_RXHead
	sts		0x0163, r1	; UART_RXTail
	cbi		portd, 2	
	sts		0x0165, r1	; UART_RXCnt
	sts		0x0164, r1	
	mov		r18, r25	
	clr		r19	
	out		ucsrc, r18	; 0x20
	out		ubrrl, r24	; 0x09
	ldi		r24, (1<<rxcie)|(1<<rxen)	; 0x90	
	out		ucsrb, r24	; 0x0a
	ldi		r24, (1<<ursel)|(1<<ucsz1)|(1<<ucsz0) ;0x86	; 134
	out		ucsrc, r24	; 0x20
	ret		


uart_getchar:			
	lds		r25, 0x0162	
	lds		r24, 0x0163	
	cp		r25, r24	
	breq	uart_getchar     	; 0x1782 <uart_getchar>
	lds		r30, 0x0163	
	subi	r30, 0xFF	; 255
	sts		0x0163, r30	
	cli		
	lds		r24, 0x0164	
	lds		r25, 0x0165	
	sbiw	r24, 0x01	; 1
	sts		0x0165, r25	
	sts		0x0164, r24	
	lds		r24, 0x0164	
	lds		r25, 0x0165	
	cpi		r24, 0xC0	; 192
	cpc		r25, r1	
	brcc	uart0x3a      	; 0x17bc <uart_getchar+0x3a>
	cbi		portd, 2	; 18
uart0x3a:
	sei		
	eor		r31, r31	
	subi	r30, 0x9E	; 158
	sbci	r31, 0xFF	; 255
	ld		r24, Z	
	eor		r25, r25	
	ret			

uart_data:			
	lds		r24, 0x0164	
	lds		r25, 0x0165	
	ret		

__vector_14 :	; Bildausgaberoutine		
	push	r16	
	in		r16, sreg	; 63
	push	r16	
	sbi		portd, 5	; 18
	push	xl	
	push	xh	
	push	r18	
	cbi		portd, 5	; 18
	lds		r18, GrayCnt	;PWM Counter fr 4 Graustufen (Bild 0x an, 1x an, 2x an)
	cpi		r18, 0x02	; 2
	brcs	frame0	; 0x17f0 <frame0>
	ldi		xl, 0x80	; 128
	rjmp	startframe	; 0x17f2 <startframe>
frame0:			
			
	ldi		xl, 0x00	; 0
startframe:			
	lds		xh, YCnt	// Zeilenadresse laden0x0167
	inc		xh	
	ldi		r18,((XSIZE/16)+XOScan) ;0x14	; 20
	cbi		portd, 4	; 18

Xshift:			// 320 bits ausgeben
	ld		r16, X+	
	ld		r16, X+	
	ld		r16, X+	
	ld		r16, X+	
	dec		r18	
	brne	Xshift	; 0x17fc <Xshift>
	cpi		xh, YMin	; 40x04// Zeilenzhler berechnen
	brne	not_firstline	; 0x1826 <not_firstline>// Bildende ?
	sbi		portd, 4	; 18
	wdr		
	lds		r18, GrayCnt	;0x0168// PWM Zhler erhhen
	inc		r18	
	cpi		r18, 0x03	; 3
	brcs	skipgcreset	; 0x1822 <skipgcreset>
	eor		r18, r18	
	sts		GrayCnt, r18	;0x0168
	rjmp	not_firstline	; 0x1826 <not_firstline>
skipgcreset:			
	sts		GrayCnt, r18	;0x0168
not_firstline:			
	cpi		xh, YScan 	; 2440xF4
	brcs	SkipAdRes	; 0x182c <SkipAdRes>
	ldi		xh, YMin-1	; 30x03// Adresszhler Reset
SkipAdRes:			
	sts		YCnt, xh	;0x0167
	pop		r18	
	pop		xh	
	pop		xl	
	pop		r16	
	out		sreg, r16	; 63
	pop		r16	
	reti		

lcd_setpixel:	;Y=r25:r24, X=r23:r22, Farbe=r20
	ldi		r18, high(YSIZE*4) 	
	cpi		r24, low(YSIZE*4)	
	cpc		r25, r18		;> 320?
	brcc	exitbit			; 0x18a2 Fehler
	cpi		r22, low(XSIZE)	; > 240 ?
	brcc	exitbit			; 0x18a2 Fehler

	ldi		r18, 239		; X-Koord drehen
	sub		r18,r22
	mov		r22,r18			; Xdispl = 239 - Xein

	mov		r21, r24		; XL nach r21	
	andi	r21, 0x07		; letzte 3 Bit von r21 isolieren
	ldi		r19, 0x80		; r19 = 10000000b
	cpi		r21, 0x00		; r21 als Bitzhler
	breq	exitshift		; 0x185a Sprung bei r21=0
shift:			
	lsr		r19		; Bit in r19 an richtige Position schieben
	dec		r21	
	brne	shift	; 0x1854 <shift>
exitshift:			
	lsr		r25	
	ror		r24	
	lsr		r25	
	ror		r24		; X / 4
	mov		xl, r24	
	mov		xh, r22		; aktuelles Byte holen
	subi	r27, (-(YMin))	; +4
	cli		
	sbi		portd, 3	; CP-bernahmeimpuls an
	ld		r21, X	
	cbi		portd, 3	; CP-bernahmeimpuls aus
	sei		
	sbrs	r20, 7		; wen Farbe.7 = 0 -> lschen
	rjmp	clrpixel	; 0x187c <clrpixel>
	or		r21, r19	; aktives Bit setzen
	st		X, r21	
	rjmp	pixel2	; 0x1884 <pixel2>

clrpixel:			
	com		r19	
	and		r21, r19	; aktives Bit lschen	
	st		X, r21	
	com		r19	
			
pixel2:			
	ori		xl, 0x80	; auf 2. Adresse wechseln
	cli		
	sbi		portd, 3	; 18
	ld		r21, X	
	cbi		portd, 3	; 18
	sei		
	sbrs	r20, 6	
	rjmp	clrpixel2	; 0x189a <clrpixel2>
	or		r21, r19	
	st		X, r21	
	rjmp	exitbit	; 0x18a2 <exitbit>
clrpixel2:			
	com		r19	
	and		r21, r19	
	st		X, r21	
	com		r19	
exitbit:			
	ret		

lcd_writebyte:	;Y: r24, X: r22, DATA: r20	
	cpi		r24, low(YSIZE/2) 	;> 320/8 ?
	brcc	exitbyte			; 0x18a2 Fehler
	cpi		r22, low(XSIZE)	; > 240 ?
	brcc	exitbyte			; 0x18a2 Fehler

	ldi		r18, 239		; X-Koord drehen
	sub		r18,r22
	mov		r22,r18			; Xdispl = 239 - Xein
	mov		xl, r24	
	add		xl, xl						
	mov		xh, r22	
	subi	xh, (-(YMin))	; 2520xFC
	st		X, r20	
	ori		r26, 0x80	; 128
	st		X, r20	
			
exitbyte:			
	ret		


lcd_writebyteg:	// Y: r24	// X: r22	// DATA: r20
	cpi		r24, low(YSIZE/2) 	;> 320/8 ?
	brcc	exitbyte2			; 0x18a2 Fehler
	cpi		r22, low(XSIZE)	; > 240 ?
	brcc	exitbyte2			; 0x18a2 Fehler

	ldi		r18, 239		; X-Koord drehen
	sub		r18,r22
	mov		r22,r18			; Xdispl = 239 - Xein

	mov		xl, r24	
	add		xl, xl						
	mov		xh, r22	
	subi	xh, (-(YMin))	; 2520xFC
	eor		r21, r21	
	eor		r22, r22	
	adc		r20, r20	
	adc		r21, r21	
	adc		r20, r20	
	adc		r22, r22	
	adc		r20, r20	
	adc		r21, r21	
	adc		r20, r20	
	adc		r22, r22	
	adc		r20, r20	
	adc		r21, r21	
	adc		r20, r20	
	adc		r22, r22	
	adc		r20, r20	
	adc		r21, r21	
	adc		r20, r20	
	adc		r22, r22	
	ldi		r23, 0xF0	; 240
	sbrs	r17, 0	
	swap	r23	
	sbrs	r17, 0
	swap	r21	
	cli		
	sbi		portd, 3	; 18
	ld		r20, X	
	cbi		portd, 3	; 18
	sei		
	and		r20, r23	
	or		r21, r20	
	st		X, r21	
	sbrs	r17, 0	
	swap	r22	
	ori		xl, 0x80	; 128
	cli		
	sbi		portd, 3	; 18
	ld		r20, X	
	cbi		portd, 3	; 18
	sei		
	and		r20, r23	
	or		r22, r20	
	st		X, r22	
exitbyte2:			
	ret		

xexitchar:			
	ret		

; Zeichen aus Font ausgeben
lcd_writechar:
; in r22 = Cursor x in 4 Bit-Schritten 0 ... 59		
; in r24 = Cursor y in 4 Bit-Schritten  0 ... 79
; in R20 = Zeichencode
; in r18 = Textcolor TC
; in r16 = Hntergrundfarbe BC
				
	cpi 	r22, (XSIZE/4)	;xsize/4=3ch=60
 	brsh 	xexitchar							
 	cpi 	r24, (YSIZE)	;50h=80	
 	brsh 	xexitchar
 	mov 	ZL, r20			;Zeichencode
 	ldi 	ZH, TEXT_Y		;Bytes pro Zeichen = 12
 	mul 	ZL, ZH
	movw 	ZL, r0
  	subi 	ZL, low(-(2*font))	;0deh Font Startadresse
 	sbci 	ZH, high(-(2*font))	;0ffh -> Z = Adresse 1. Bye des Zeichens 
 
 	ldi 	r21, 4			;4 Doppelspalten pro Zeichen

 	mov 	r25, r16
	and 	r25, r18		// Bits die auf jedenfall gesetzt werden
	or 		r18, r16		// Bits die auf nie gesetzt werden

 	lsl 	r22				;X-Adresse *4 auf 1-bit-Adresse
	lsl		r22			;
	ldi		xh,(Xsize-1+Ymin)	; 239 + 4 (Achse drehen 0 = 239 + offset)
	sub		xh,r22
	mov		r22,xh

	sbrc	r24,0
	rjmp	wchar2a			;Sprung ungerade Adresse


	;        | Adr. y				   | Adr. y+2
	;Zeile 1:  1.7 ...1.4 | 1.3 .. 1.0 | 2.7 .. 2.4 |
	;Zeile 2:  2.3 .. 2.0 | 3.7 .. 3.4 | 3.3 .. 3.0 |

wchar1:
	lpm 	r20, Z+			;Zeichenbyte holen
	mov 	XL, r24			;Low(Zeilenadresse)

 	rcall	dataus

	inc		xl
	inc		xl				;Adr auf Y+2
	ld		r20,x			;akt. 1.Bildinhalt 2.byte holen
	andi	r20,$0f			;H-Teil lschen
	mov		r0,r20
	lpm		r20,z			;2.Zeichen-Byte holen

	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	clr		r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	; 255

	andi	r20,$f0			;L-Teil lschen
	or		r20,r0			;und neuen Inhalt einfgen
	st		X,r20			;und speichern

	ori		xl, 0x80
	ld		r22,x			;akt. 2.Bildinhalt 2.byte holen
	andi	r22,$0f			;H-Teil lschen
	mov		r0,r22
	lpm		r22,z			;2.Zeichen-Byte holen

	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	clr		r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	; 255

	andi	r22,$f0			;L-Teil lschen
	or		r22,r0			;und neuen Inhalt einfgen
	st		X,r22
	andi	xl,0x7f

	dec		xl
	dec		xl				;Adresse zurck auf Y
	dec		xh				;2. Zeichenspalte

	clr		r0
	lpm		r20,z+			;2. Byte L-Nibble holen
	swap	r20				;in high-Nibble schieben
	andi	r20,$f0			;und isolieren
	or		r0,r20			;
	lpm		r20,z			;3. Byte H-Teil
	swap	r20				;in low-Nibble schieben
	andi	r20,$0f			;und isolieren
	or		r20,r0			;Nibble vereinigen

	rcall	dataus

	inc		xl
	inc		xl				;Adr auf "Y+2"
	ld		r20,x			;akt. 1. Bildinhalt Y+2 holen

	andi	r20,$0f			;oberen Nibble lschen
	mov		r0,r20
	lpm		r20,z			;3. Byte L-Nibble holen

	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	clr		r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	; 255

	swap	r20				;in high-Nibble schieben
	andi	r20,$f0			;und isolieren
	or		r20,r0			;Nibble zusammenfgen
	st		X,r20			;und speichern

	ori		xl, 0x80	

	ld		r22,x			;akt. 2.Bildinhalt Y+2 holen
	andi	r22,$0f			;oberen Nibble lschen
	mov		r0,r22
	lpm		r22,z+			;3. Byte L-Nibble holen

	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	clr		r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	; 255

	swap	r22				;in high-Nibble schieben
	andi	r22,$f0			;und isolieren
	or		r22,r0			;Nibble zusammenfgen
	st		X,r22			;und speichern
	andi	xl,0x7f

	dec		xl
	dec		xl				;zurck auf Adresse "Y
	dec		xh				;Adresse neue Spalte
 	dec 	r21
 	brne 	wchar1a
 	clr 	r1
 exitchar:
	ret
wchar1a:
	rjmp	wchar1

	;        | Adr. y	  | Adr. y+2
   ;Spalte 1:  1.7 ...1.4 | 1.3 .. 1.0 | 2.7 .. 2.4 |
   ;Spalte 2:  2.3 .. 2.0 | 3.7 .. 3.4 | 3.3 .. 3.0 |

wchar2a:
	dec		r24			; Adresse vorgehendes Byte
wchar2:
	mov 	XL, r24			;Low(Spaltenadresse) 

 	ld 		r20,X			;aktuelles Byte aus 1. Bildspeicher holen
	andi	r20,$f0			;unteres Nibble lschen
	mov		r0,r20
	lpm 	r20,Z			;1. Zeichenbyte holen

	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	eor		r20, r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	; 255

	swap	r20
	andi	r20,$0f			;oberes Nibble isolieren
	or		r20,r0			;und in unteres Nibble einfgen
	st		X,r20			;und speichern

	ori		xl, 0x80	; 128

 	ld 		r22,X			;aktuelles Byte aus 2. Bildspeicher holen
	andi	r22,$f0			;unteres Nibble lschen
	mov		r0,r22
	lpm 	r22,Z			;1. Zeichenbyte holen

	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	eor		r22, r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	; 255

	swap	r22
	andi	r22,$0f			;oberes Nibble isolieren
	or		r22,r0			;und in unteres Nibble einfgen
	st		X,r22			;und speichern

	andi	xl,0x7f

	inc		xl
	inc		xl				;Adr auf Y+2
	clr		r0
	lpm 	r20,Z+			;1. Zeichenbyte holen
	swap	r20
	andi	r20,$f0			;unteres Nibble isolieren
	or		r0,r20			;in oberes Nibble einfgen
	lpm		r20,Z			;2. Zeichenbyte holen
	swap	r20
	andi	r20,$0f			;oberes Nibble isolieren
	or		r20,r0			;als unteres Nibble einfgen

	rcall	dataus

	dec		xl
	dec		xl				;zurck auf Adr. Y
	dec		xh				;2. Zeichenspalte
	ld 		r20,X			;Adr. "Y" holen
	andi	r20,$f0			;unteres Nibble lschen
	mov		r0,r20
	lpm		r20,Z			;2. Zeichenbyte holen

	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	eor		r20, r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	; 255

	andi	r20,$0f			;oberes Nibble lschen
	or		r20,r0			;Zeichencode einbauen
	st		X,r20			;und speichern

	ori		xl, 0x80	; 128

	ld 		r22,X			;Adr. "Y" holen
	andi	r22,$f0			;unteres Nibble lschen
	mov		r0,r22
	lpm		r22,Z+			;2. Zeichenbyte holen

	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	eor		r22, r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	; 255

	andi	r22,$0f			;oberes Nibble lschen
	or		r22,r0			;Zeichencode einbauen
	st		X,r22			;und speichern

	andi	xl,0x7f

	inc		xl
	inc		xl				;Adr. auf Y+1
	lpm		r20,Z+			;3. Zeichenbyte holen

	rcall	dataus

	dec		xl
	dec		xl				; zurck auf Adresse "Y"
	dec		xh				; Adresse neue Spalte

 	dec 	r21
 	brne 	wchar2b
	clr 	r1
 	ret
wchar2b:
	rjmp	wchar2

dataus:
	mov 	r22, r20
	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	eor		r20, r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	; 255
	st		X, r20	
	ori		r26, 0x80	; 128
	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	eor		r22, r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	; 255
	st		X, r22	
	andi	xl,0x7f
	ret


lcd_writeschar:
 	ldi 	r21, 4			;4 Doppelspalten pro Zeichen

 	mov 	r25, r16
	and 	r25, r18		// Bits die auf jedenfall gesetzt werden
	or 		r18, r16		// Bits die auf nie gesetzt werden

 	lsl 	r22				;X-Adresse *4 auf 1-bit-Adresse
	lsl		r22			;
	ldi		xh,(Xsize-1+Ymin)	; 239 + 4 (Achse drehen 0 = 239 + offset)
	sub		xh,r22
	mov		r22,xh

	sbrc	r24,0
	rjmp	swchar2a			;Sprung ungerade Adresse


	;        | Adr. y				   | Adr. y+2
	;Zeile 1:  1.7 ...1.4 | 1.3 .. 1.0 | 2.7 .. 2.4 |
	;Zeile 2:  2.3 .. 2.0 | 3.7 .. 3.4 | 3.3 .. 3.0 |

swchar1:
	ld	 	r20, Z+			;Zeichenbyte holen
	mov 	XL, r24			;Low(Zeilenadresse)

	rcall	dataus

	inc		xl
	inc		xl				;Adr auf Y+2
	ld		r20,x			;akt. 1.Bildinhalt 2.byte holen
	andi	r20,$0f			;H-Teil lschen
	mov		r0,r20
	ld		r20,z			;2.Zeichen-Byte holen

	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	clr		r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	; 255

	andi	r20,$f0			;L-Teil lschen
	or		r20,r0			;und neuen Inhalt einfgen
	st		X,r20			;und speichern

	ori		xl, 0x80

	ld		r22,x			;akt. 2.Bildinhalt 2.byte holen
	andi	r22,$0f			;H-Teil lschen
	mov		r0,r22
	ld		r22,z			;2.Zeichen-Byte holen

	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	clr		r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	; 255

	andi	r22,$f0			;L-Teil lschen
	or		r22,r0			;und neuen Inhalt einfgen
	st		X,r22

	andi	xl,0x7f

	dec		xl
	dec		xl				;Adresse zurck auf Y
	dec		xh				;2. Zeichenspalte

	clr		r0
	ld		r20,z+			;2. Byte L-Nibble holen
	swap	r20				;in high-Nibble schieben
	andi	r20,$f0			;und isolieren
	or		r0,r20			;
	ld		r20,z			;3. Byte H-Teil
	swap	r20				;in low-Nibble schieben
	andi	r20,$0f			;und isolieren
	or		r20,r0			;Nibble vereinigen

	rcall	dataus

	inc		xl
	inc		xl				;Adr auf "Y+2"
	ld		r20,x			;akt. 1. Bildinhalt Y+2 holen

	andi	r20,$0f			;oberen Nibble lschen
	mov		r0,r20
	ld		r20,z			;3. Byte L-Nibble holen

	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	clr		r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	; 255

	swap	r20				;in high-Nibble schieben
	andi	r20,$f0			;und isolieren
	or		r20,r0			;Nibble zusammenfgen
	st		X,r20			;und speichern

	ori		xl, 0x80	

	ld		r22,x			;akt. 2.Bildinhalt Y+2 holen
	andi	r22,$0f			;oberen Nibble lschen
	mov		r0,r22
	ld		r22,z+			;3. Byte L-Nibble holen

	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	clr		r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	; 255

	swap	r22				;in high-Nibble schieben
	andi	r22,$f0			;und isolieren
	or		r22,r0			;Nibble zusammenfgen
	st		X,r22			;und speichern
	andi	xl,0x7f

	dec		xl
	dec		xl				;zurck auf Adresse "Y
	dec		xh				;Adresse neue Spalte
 	dec 	r21
 	brne 	swchar1a
 	clr 	r1
;sexitchar:
	ret
swchar1a:
	rjmp	swchar1

	;        | Adr. y	  | Adr. y+2
   ;Spalte 1:  1.7 ...1.4 | 1.3 .. 1.0 | 2.7 .. 2.4 |
   ;Spalte 2:  2.3 .. 2.0 | 3.7 .. 3.4 | 3.3 .. 3.0 |

swchar2a:
	dec		r24			; Adresse vorgehendes Byte
swchar2:
	mov 	XL, r24			;Low(Spaltenadresse) 

 	ld 		r20,X			;aktuelles Byte aus 1. Bildspeicher holen
	andi	r20,$f0			;unteres Nibble lschen
	mov		r0,r20
	ld	 	r20,Z			;1. Zeichenbyte holen

	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	clr		r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	

	swap	r20
	andi	r20,$0f			;oberes Nibble isolieren
	or		r20,r0			;und in unteres Nibble einfgen
	st		X,r20			;und speichern

	ori		xl, 0x80	

 	ld 		r22,X			;aktuelles Byte aus 2. Bildspeicher holen
	andi	r22,$f0			;unteres Nibble lschen
	mov		r0,r22
	ld	 	r22,Z			;1. Zeichenbyte holen

	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	clr		r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	

	swap	r22
	andi	r22,$0f			;oberes Nibble isolieren
	or		r22,r0			;und in unteres Nibble einfgen
	st		X,r22			;und speichern

	andi	xl,0x7f

	inc		xl
	inc		xl				;Adr auf Y+2
	clr		r0
	ld	 	r20,Z+			;1. Zeichenbyte holen
	swap	r20
	andi	r20,$f0			;unteres Nibble isolieren
	or		r0,r20			;in oberes Nibble einfgen
	ld		r20,Z			;2. Zeichenbyte holen
	swap	r20
	andi	r20,$0f			;oberes Nibble isolieren
	or		r20,r0			;als unteres Nibble einfgen

	rcall	dataus

	dec		xl
	dec		xl				;zurck auf Adr. Y
	dec		xh				;2. Zeichenspalte
	ld 		r20,X			;Adr. "Y" holen
	andi	r20,$f0			;unteres Nibble lschen
	mov		r0,r20
	ld		r20,Z			;2. Zeichenbyte holen

	sbrc	r16, 7	// Wenn Hintergrund an: Bits invertieren 
	com		r20	
	sbrs	r18, 7	// Wenn nichts an: Bits lschen
	clr		r20	
	sbrc	r25, 7	// Wenn beides an: Bits setzen
	ldi		r20, 0xFF	; 255

	andi	r20,$0f			;oberes Nibble lschen
	or		r20,r0			;Zeichencode einbauen
	st		X,r20			;und speichern

	ori		xl, 0x80	; 128
	ld 		r22,X			;Adr. "Y" holen
	andi	r22,$f0			;unteres Nibble lschen
	mov		r0,r22
	ld		r22,Z+			;2. Zeichenbyte holen

	sbrc	r16, 6	// Wenn Hintergrund an: Bits invertieren 
	com		r22	
	sbrs	r18, 6	// Wenn nichts an: Bits lschen
	clr		r22	
	sbrc	r25, 6	// Wenn beides an: Bits setzen
	ldi		r22, 0xFF	; 255

	andi	r22,$0f			;oberes Nibble lschen
	or		r22,r0			;Zeichencode einbauen
	st		X,r22			;und speichern
	andi	xl,0x7f

	inc		xl
	inc		xl				;Adr. auf Y+1
	ld		r20,Z+			;3. Zeichenbyte holen

	rcall	dataus

	dec		xl
	dec		xl				; zurck auf Adresse "Y"
	dec		xh				; Adresse neue Spalte

 	dec 	r21
 	brne 	swchar2b
	clr 	r1
 	ret
swchar2b:
	rjmp	swchar2

Startbild:
	.db	$1d,$0a,$0a,$00,$e5,$4f,$00,$00,$ff,$1d,$0f,$0f,$00,$4a,$4a,$00,$40,$ff	
	.db	$1d,$8c,$0f,$00,$b3,$2d,$00,$40,$40,$1d,$a0,$28,$00,$c7,$4b,$00,$80,$80	
	.db	$1d,$b4,$14,$00,$db,$32,$00,$ff,$ff,$00	
	.db	$11,$02,$15,$15,$ff,$00,"240x320 LCD Controller"	;
	.db	$11,$02,$19,$15,$80,$00,$b8," by Benedikt & Horst-Dieter" 
	.db	$13,$77,$c8,$00,$28,$40,$ff,$00	
Anzahl:
	.db	115,0  ;Anzahl zu bertragende Zeichen
